riot.tag2('history', '<h2>History</h2> <div><button onclick="{clearHistory}">Clear</button></div> <div class="historyRow" each="{history}"> <div class="projectTime">{time}</div> <div class="projectName">{name}</div> </div>', 'history .historyRow,[data-is="history"] .historyRow{ margin: 20px; } history .projectName,[data-is="history"] .projectName{ display: inline-block; width: 70%; }', '', function(opts) {
		RiotControl.addStore(this);

		this.clearHistory = function(e) {
			e.preventDefault();
			RiotControl.trigger('clear-history');
		}.bind(this)

		this.on('history-changed', function(history){
			console.log("history-changed on history.tag", history);
			this.history = history;
			this.update();
		});

		RiotControl.trigger("get-history");
});
riot.tag2('peer-ball', '<button onclick="{selectProject}">Peer</button> <div class="ball"><p>{selectedProjectText}</p></div>', 'peer-ball { display: block; text-align: center; width: 100%; } peer-ball .ball,[data-is="peer-ball"] .ball{ display: table; width: 200px; height: 200px; border-radius: 50%; background-color: black; color: white; padding: 20px; margin-left: auto; margin-right: auto; margin-top: 10px; font-size: 24px; } peer-ball .ball p,[data-is="peer-ball"] .ball p{ display: table-cell; text-align: center; vertical-align: middle; }', '', function(opts) {
		RiotControl.addStore(this);
		this.selectedProjectText = "Peer into the magic ball to see what project you should work on."
		this.selectProject = function(e){
			RiotControl.trigger("select-project");
		}.bind(this)
		this.on("project-selected", function(selectedProject){
			console.log("project-selected on peer-ball.tag", selectedProject);
			this.selectedProjectText = "You must work on... "+selectedProject.name;
		})
		this.on("no-project-available", function(){
			console.log("no-project-available on peer-ball.tag");
			this.selectedProjectText = "You must add some projects first"
		});
});
riot.tag2('project-picker', '<peer-ball projects="{projects}"></peer-ball> <projects projects="{projects}"></projects> <history></history>', '', '', function(opts) {
});
riot.tag2('projects', '<form onsubmit="{add}"> <p>Add project: <input ref="input"></p> <p><button>Add</button></p> </form> <div class="projectRow" each="{projects}"> <div class="projectName">{name}</div> <div class="buttonColumn"><button onclick="{remove}">X</button></div> </div>', 'projects .projectRow,[data-is="projects"] .projectRow{ margin: 20px; } projects .projectName,[data-is="projects"] .projectName{ display: inline-block; width: 70%; } projects .buttonColumn,[data-is="projects"] .buttonColumn{ display: inline-block; width: 10%; vertical-align: top; }', '', function(opts) {
		RiotControl.addStore(this);
		this.projects = opts.projects;
		this.add = function(e) {
			e.preventDefault();
			var projectName = this.refs.input.value.trim();
			if (projectName === ""){
				return;
			}
			this.refs.input.value = '';
			RiotControl.trigger('add-project', { name: projectName });
		}.bind(this)

		this.remove = function(e){
			const nameToRemove = e.item.name;
			RiotControl.trigger('remove-project', nameToRemove);
		}.bind(this)

		this.on('projects-changed', function(projects){
			console.log("projects-changed on projects.tag", projects);
			this.projects = projects;
		}.bind(this));
		RiotControl.trigger("get-projects");
});